// ======================= //
// color
// ======================= //
function columnsColorPicker() {
  var ecColorInput = document.getElementById('ctrl_column_color');
  if (ecColorInput) {
    var divColorPrev = document.createElement("div");
    divColorPrev.classList.add("color-preview");
    ecColorInput.parentElement.append(divColorPrev);
    divColorPrev.style.background = '#'+ecColorInput.value;

    // on input change
    ecColorInput.addEventListener('input', function (evt) {
        divColorPrev.style.background = '#'+ecColorInput.value
    });

    // when color is changed by colorpicker
    var ctrlColorButton = document.querySelectorAll('#ctrl_column_color .moor-okButton');
    ctrlColorButton[0].onclick = function(){
        divColorPrev.style.background = '#'+ecColorInput.value
    };
  }
}


// ======================= //
// cols preview
// ======================= //
// functions
function columnsUpdateCols(container) {
  // cols
  var cols = container.querySelectorAll('.cols_preview .col');

  var widths = container.querySelectorAll('select[id*="_width"]');
  var offsets = container.querySelectorAll('select[id*="_offset"]');
  var aligns = container.querySelectorAll('select[id*="_align"]');
  var orders = container.querySelectorAll('select[id*="_order"]');

  for (var i = 0; i < cols.length; i++) {
    var colClass = 'col colsPart_'+(parseInt(i)+1);
    // width
    var widthTxt = widths[i].value;
    if (widthTxt === 'auto') {
      colClass += ' col-sm';
    } else {
      colClass += ' col-sm-'+widthTxt;
    }
    // offset
    var offsetTxt = offsets[i].value;
    if (offsetTxt) {
      colClass += ' col-sm-offset-'+offsetTxt;
    }
    // align
    var alignTxt = aligns[i].value;
    if (alignTxt) {
      colClass += ' col-sm-align-'+alignTxt;
    }
    // order
    var orderTxt = orders[i].value;
    if (orderTxt) {
      colClass += ' col-sm-order-'+orderTxt;
    }

    cols[i].setAttribute('class', colClass);
  }
}

function columnsUpdateRow() {
  var justify = document.getElementById('ctrl_column_justify');
  var align = document.getElementById('ctrl_column_align');
  // rows
  var allRows = container.querySelectorAll('.widget-columns-container .row');
  for (var i = 0; i < allRows.length; i++) {
    var rowClass = 'row';
    if (justify.value) {
      rowClass += ' justify-'+justify.value;
    }
    if (align.value) {
      rowClass += ' align-'+align.value;
      rowClass += ' align_preview_fix';
    }
    allRows[i].setAttribute('class', rowClass);
  }
}


function columnsCreatePreviewContainer() {

  // Create preview container
  var columnsContainer = document.getElementsByClassName('widget-columns-container');

  for (colContainerIndex = 0; colContainerIndex < columnsContainer.length; ++colContainerIndex) {
    // container
    divColsPreview = document.createElement('div');
    divColsPreview.setAttribute('class', 'cols_preview');
    columnsContainer[colContainerIndex].appendChild(divColsPreview);

    // row
    divColsPreviewRow = document.createElement('div');
    divColsPreviewRow.setAttribute('class', 'row');
    divColsPreview.appendChild(divColsPreviewRow);

    // cols
    var tr = columnsContainer[colContainerIndex].querySelectorAll('tbody > tr');
    for (trIndex = 0; trIndex < tr.length; ++trIndex) {
      col = document.createElement('div');
      col.setAttribute('class', 'col colsPart_' + (trIndex+1));
      col.innerHTML = '<div class="box"><p class="col_index">' + (trIndex+1) + '</p></div>';

      divColsPreviewRow.appendChild(col);
    }

    // call functions on start
    columnsUpdateCols(columnsContainer[colContainerIndex]);
    columnsUpdateRow();
  }

  // call functions when any select is changed
  var selects = document.querySelectorAll('.widget-columns-container select');
  if (selects) {
    for (var selectIndex = 0; selectIndex < selects.length; selectIndex++) {
      selects[selectIndex].addEventListener("change", function(ele){
        var parent = ele.srcElement.closest(".widget-columns-container");
        columnsUpdateCols(parent);
      });
    }
  }
  var selectJustify = document.getElementById('ctrl_column_justify');
  if (selectJustify) {
    selectJustify.addEventListener("change", function(){
      columnsUpdateRow();
    });
  }
  var selectAlign = document.getElementById('ctrl_column_align');
  if (selectAlign) {
    selectAlign.addEventListener("change", function(){
      columnsUpdateRow();
    });
  }

}

window.addEventListener('load', function () {
  columnsColorPicker();
  columnsCreatePreviewContainer();
});
